//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

extern int    FastEma         = 5;
extern int    SlowEma         = 8;
extern int    Price           = PRICE_CLOSE;
extern int    BarToTest       = 1;
extern string ___             = "Alerts";
extern bool   alertsOn        = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsNotify    = false;
extern bool   alertsEmail     = false;
extern string alertsSoundName = "alert1.wav";

int init()   { return (0); }
int deinit() { return (0); }
int start()
{
   double macdc = iMA(NULL,0,FastEma,0,MODE_EMA,Price,BarToTest  )-iMA(NULL,0,SlowEma,0,MODE_EMA,Price,BarToTest  );
   double macdp = iMA(NULL,0,FastEma,0,MODE_EMA,Price,BarToTest+1)-iMA(NULL,0,SlowEma,0,MODE_EMA,Price,BarToTest+1);
      if (macdc>0 && macdp>0) return(0);
      if (macdc<0 && macdp<0) return(0);
   
      //
      //
      //
      //
      //
      
      for (int i=OrdersTotal()-1; i>=0; i--)
      {
         if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
         if (OrderSymbol()!=Symbol())                   continue;
         
         //
         //
         //
         //
         //
         
         int type   = OrderType();
         int ticket = OrderTicket();
            switch (type)
            {
               case OP_BUY       :
               case OP_SELL      : OrderClose(ticket,OrderLots(),OrderClosePrice(),0,Red); break;
               case OP_BUYSTOP   :
               case OP_BUYLIMIT  :
               case OP_SELLSTOP  :
               case OP_SELLLIMIT : OrderDelete(ticket); break;
               default : break;
            }
            if (alertsOn) DisplayAlert((type)+" order closed "); 
      }
   return (0); 
}

//
//
//
//
//

void DisplayAlert(string doWhat)
{
    int shift;
    string message;
    static datetime lastAlertTime;
    if(shift <= 2 && Time[0] != lastAlertTime)
    {
      message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Close on EMA cross ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," Close on EMA cross " +" "+message));
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Close on EMA cross "),message);
          if (alertsSound)   PlaySound(alertsSoundName); 
          lastAlertTime = Time[0];
    }
}